#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define ios ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define vl vector<ll>
#define vvl vector<vl>
#define pl pair<ll,ll>
#define vp vector<pl>

const ll mod = 1e9;

void Solve();

signed main() {
    ll t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
    return 0;
}

void Solve() {
    ll n, f, h = 0, ans; cin >> n >> f;
    vl d(n);
    if (f == 1) {
        for (int i = 0; i < n; ++i) {
            cin >> d[i];
            h = max(h, d[i]);
        }
    } else {
        ll m, x, y, z; cin >> m >> x >> y >> z;
        for (int i = 0; i < m; ++i) {
            cin >> d[i];
            h = max(h, d[i]);
        }
        for (int i = m; i < n; ++i) {
            d[i] = ((x * d[i - 2]) + (y * d[i - 1]) + z) % mod + 1;
            h = max(h, d[i]);
        }
    }
    ll l = -1, r = h + 1;
    while (r - l > 1) {
        ll m = (r + l) / 2;
        ll start = 0;
        for (int i = 0; i < n; ++i) {
            ll bonus = i - start;
            if (m + bonus < d[i]) {
                start = i + 1;
            }
        }
        if (start == n) {
            l = m;
        } else {
            ll bonus = n - start;
            bool fine = true;
            for (int i = 0; i < start; ++i) {
                if (m + bonus + i < d[i]) {
                    fine = false;
                    break;
                }
            }
            if (!fine) {
                l = m;
            } else {
                r = m;
                ans = start;
            }
        }
    }
    cout << r << " " << ans + 1;
}
