#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define ios ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define vl vector<ll>
#define vvl vector<vl>
#define pl pair<ll,ll>
#define vp vector<pl>

vector<vector<pair<ll, int>>> g(100000);
vector<bool> used(100000);
vector<vector<int>> ans(10000);
ll sum = 0, k = 0, cnt = 0;

void Solve();
void dfs(ll v, ll u, ll p);

signed main() {
    ios;
    ll t = 1;
//    cin >> t;
    while (t--) {
        Solve();
    }
    return 0;
}

void Solve() {
    ll n;
    cin >> n >> k;
    for (int i = 1; i < n; ++i) {
        ll p, w;
        cin >> p >> w;
        p--;
        g[p].push_back({w, i});
        g[i].push_back({w, p});
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    dfs(0, -1, 0);
    cout << cnt << " " << sum;
}

void dfs(ll v, ll u, ll p) {
    used[v] = true;
    for (int i = 0; i < (int) g[v].size(); ++i) {
        if (!used[g[v][i].second]) {
            dfs(g[v][i].second, v, g[v][i].first);
        }
    }
    if (v != 0) {
        if ((int) ans[v].size() < k && (int) ans[u].size() < k) {
            ans[v].push_back(u);
            ans[u].push_back(v);
            sum += p;
            cnt++;
        }
    }
}
